#!/bin/bash

function success(){
  echo -e "\e[92m"$1"\e[0m"
}
function warn(){
  echo -e "\e[93m"$1"\e[0m"
}
function error(){
  echo -e "\e[91m"$1"\e[0m"
}

pghome="/data/pgsql/data"
export PGPASSWORD="Informat-Next_#,.20221001"

echo "postgres ALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers
echo 'export PS1="[\u@\h \W]$ "' >> /etc/profile
echo "postgres:Informat-Next_#,.20221001" | chpasswd
echo "export PATH=/usr/local/pgsql/bin:$PATH" >> /etc/profile
source /etc/profile

cd "$(dirname "$0")"

FULL_PATH=$(pwd)

ufw allow 5432/tcp
ufw allow 9999/tcp
ufw allow 9000/tcp
ufw allow 9694/tcp
ufw allow 9898/tcp
ufw reload

tar -xzvf pgpool-II-4.3.8.tar.gz
cd pgpool-II-4.3.8
./configure --sysconfdir=/etc/pgpool-II --with-pgsql=/usr/local/pgsql
make && make install
echo '/usr/local/lib' | tee /etc/ld.so.conf.d/usr_local_lib.conf
ldconfig

cd src/sql/pgpool-recovery/
make && make install

if [ ! -d "/etc/pgpool-II" ]; then
  error "pgpool 安装失败"
  exit 1
else
  success "pgpool 安装成功"
fi

cd $FULL_PATH

if [ ! -d "/var/run/postgresql" ]; then
  mkdir /var/run/postgresql
  chown -R postgres:postgres /var/run/postgresql
  chmod 700 /var/run/postgresql
  success "创建目录【/var/run/postgresql】成功"
fi

if [ ! -d "/var/log/pgpool_log" ]; then
  mkdir /var/log/pgpool_log
  chown -R postgres:postgres /var/log/pgpool_log
  success "创建目录【/var/log/pgpool_log】成功"
fi

if [ ! -f "/etc/systemd/system/pgpool.service" ]; then
  cp -vf pgpool.service /etc/systemd/system
  success "复制pgpool.service成功"
else
  warn "pgpool.service已存在"
fi

cp -vf pool_hba.conf /etc/pgpool-II
chown -R postgres:postgres /etc/pgpool-II

mkdir -p /var/lib/pgsql/archivedir
chown -R postgres:postgres /var/lib/pgsql/archivedir

cp -vf *.conf $pghome
chown -R postgres:postgres /data/pgsql/data

systemctl restart postgresql-13
systemctl status postgresql-13

echo "修改数据库密码为MD5加密"
psql -U postgres -p 5432 -h 127.0.0.1 -c "alter user postgres with encrypted password 'Informat-Next_#,.20221001';"
echo "创建数据库pgpool账号密码"
psql -U postgres -p 5432 -h 127.0.0.1 -c "CREATE ROLE pgpool WITH LOGIN;alter user pgpool with encrypted password 'Informat-Next_#,.20221001';GRANT pg_monitor TO pgpool;"
